#ifndef __SPRINGPROXACTIVEXCTL_H__
#define __SPRINGPROXACTIVEXCTL_H__

#include "resource.h"

/////////////////////////////////////////////////////////////////////////////
// CSpringProxActiveXCtl
/////////////////////////////////////////////////////////////////////////////
class ATL_NO_VTABLE CSpringProxActiveXCtl : 
    public CComObjectRootEx<CComSingleThreadModel>,
    public CComCoClass<CSpringProxActiveXCtl, &CLSID_SpringProxActiveXCtl>,

    public IDispatchImpl<ISpringProxActiveXCtl, &IID_ISpringProxActiveXCtl, &LIBID_SPRINGPROXACTIVEXLib>,
    public IProvideClassInfoImpl<&CLSID_SpringProxActiveXCtl, &LIBID_SPRINGPROXACTIVEXLib>,

    public CComControl<CSpringProxActiveXCtl>,
    public IOleControlImpl<CSpringProxActiveXCtl>,
    public IOleObjectImpl<CSpringProxActiveXCtl>,
    public IViewObjectExImpl<CSpringProxActiveXCtl>,
    public IOleInPlaceActiveObjectImpl<CSpringProxActiveXCtl>,
    public IOleInPlaceObjectWindowlessImpl<CSpringProxActiveXCtl>,

    public IPersistPropertyBagImpl<CSpringProxActiveXCtl>,

    public IObjectSafetyImpl<CSpringProxActiveXCtl, INTERFACESAFE_FOR_UNTRUSTED_CALLER | INTERFACESAFE_FOR_UNTRUSTED_DATA>
{
// Construction/Destruction
public:
	CSpringProxActiveXCtl();
  ~CSpringProxActiveXCtl();

    DECLARE_REGISTRY_RESOURCEID(IDR_SPRINGPROXACTIVEXCTL)
    DECLARE_PROTECT_FINAL_CONSTRUCT()

    static LPCTSTR GetWindowClassName()
    { return TEXT("CSpringProxActiveXCtl"); }

// Methods
protected:
    HRESULT OnDraw(ATL_DRAWINFO& di);

// Interfaces
public:
    BEGIN_COM_MAP(CSpringProxActiveXCtl)
	    COM_INTERFACE_ENTRY(ISpringProxActiveXCtl)

	    COM_INTERFACE_ENTRY(IDispatch)
        COM_INTERFACE_ENTRY(IProvideClassInfo)

        COM_INTERFACE_ENTRY_IMPL(IOleControl)
        COM_INTERFACE_ENTRY_IMPL(IOleObject)
        COM_INTERFACE_ENTRY_IMPL(IViewObjectEx)
        COM_INTERFACE_ENTRY_IMPL_IID(IID_IViewObject2, IViewObjectEx)
        COM_INTERFACE_ENTRY_IMPL_IID(IID_IViewObject, IViewObjectEx)
        COM_INTERFACE_ENTRY_IMPL_IID(IID_IOleWindow, IOleInPlaceObjectWindowless)
        COM_INTERFACE_ENTRY_IMPL_IID(IID_IOleInPlaceObject, IOleInPlaceObjectWindowless)
        COM_INTERFACE_ENTRY_IMPL_IID(IID_IOleWindow, IOleInPlaceActiveObject)
        COM_INTERFACE_ENTRY_IMPL(IOleInPlaceActiveObject)
        COM_INTERFACE_ENTRY_IMPL(IOleInPlaceObjectWindowless)

        COM_INTERFACE_ENTRY_IMPL(IPersistPropertyBag)
        COM_INTERFACE_ENTRY_IMPL_IID(IID_IPersist, IPersistPropertyBag)

        COM_INTERFACE_ENTRY(IObjectSafety)
    END_COM_MAP()

  /* Shared with Win32 implementation */	
	#include "springproxactivexctl_impl.h"

};

#endif //__SPRINGPROXACTIVEXCTL_H__

