#ifndef _DESFIRE_I_H_
#define _DESFIRE_I_H_

#ifdef WIN32
#define SPROX_DESFIRE_LIB __declspec( dllexport )
#endif

#include "sprox_desfire.h"

#ifndef WIN32
  #define _T(x) x
#endif

#define	INVALIDATE_AUTHENTICATION	   0xFF

/*
 * DESFire commands (codes sent by the PCD)
 * ----------------------------------------
 */

#define DF_AUTHENTICATE                     0x0A
#define DF_CREDIT                           0x0C
#define DF_LIMITED_CREDIT                   0x1C
#define DF_WRITE_RECORD                     0x3B
#define DF_WRITE_DATA                       0x3D
#define DF_GET_KEY_SETTINGS                 0x45
#define DF_CHANGE_KEY_SETTINGS              0x54
#define DF_SELECT_APPLICATION               0x5A
#define DF_CHANGE_FILE_SETTINGS             0x5F
#define DF_GET_VERSION                      0x60
#define DF_GET_KEY_VERSION                  0x64
#define DF_GET_APPLICATION_IDS              0x6A
#define DF_GET_VALUE                        0x6C
#define DF_GET_FILE_IDS                     0x6F
#define DF_ABORT_TRANSACTION                0xA7
#define DF_READ_RECORDS                     0xBB
#define DF_READ_DATA                        0xBD
#define DF_CREATE_CYCLIC_RECORD_FILE        0xC0
#define DF_CREATE_LINEAR_RECORD_FILE        0xC1
#define DF_CHANGE_KEY                       0xC4
#define DF_COMMIT_TRANSACTION               0xC7
#define DF_CREATE_APPLICATION               0xCA
#define DF_CREATE_BACKUP_DATA_FILE          0xCB
#define DF_CREATE_VALUE_FILE                0xCC
#define DF_CREATE_STD_DATA_FILE             0xCD
#define DF_DELETE_APPLICATION               0xDA
#define DF_DEBIT                            0xDC
#define DF_DELETE_FILE                      0xDF
#define DF_CLEAR_RECORD_FILE                0xEB
#define DF_GET_FILE_SETTINGS                0xF5
#define DF_FORMAT_PICC                      0xFC

#endif
