#ifndef __FINGERTK_H__
#define __FINGERTK_H__

#pragma pack(1)

typedef struct
{
  char  id[20];
  char  lastname[40];
  char  firstname[40];
  BYTE  finger1_type;
  WORD  finger1_len;
  BYTE  finger1_data[256];
  BYTE  finger2_type;
  WORD  finger2_len;
  BYTE  finger2_data[256];
} FINGERTK_DATA_ST;

/* Size = 618 */

/* From verify.c */
void verify(FINGERTK_DATA_ST *data);
BYTE verify_twic(BYTE *twic_data, WORD twic_size);

/* From enroll.c */
BOOL enroll(FINGERTK_DATA_ST *data);

/* From tags.c */
BOOL read_from_tag(FINGERTK_DATA_ST *data);
BOOL read_from_tag_sagem(FINGERTK_DATA_ST *data);
BOOL read_from_tag_twic(FINGERTK_DATA_ST *data);
void write_to_tag(FINGERTK_DATA_ST *data);

/* From files.c */
void save_to_file(FINGERTK_DATA_ST *data);
BOOL load_from_file(FINGERTK_DATA_ST *data);

/* From msoilv.c */
BOOL ilv_loop(BYTE *buffer, WORD *offset, BYTE *tag, WORD *length, BYTE **value);
void ilv_init(BYTE *buffer, WORD *size, BYTE tag);
void ilv_final(BYTE *buffer, WORD *size);
void ilv_add_word(BYTE *buffer, WORD *size, WORD value);
void ilv_add_dword(BYTE *buffer, WORD *size, DWORD value);
void ilv_add_byte(BYTE *buffer, WORD *size, BYTE value);
void ilv_add_data(BYTE *buffer, WORD *size, BYTE *data, WORD length);

#endif
