// finger_tkDlg.cpp : implementation file
//

#include "stdafx.h"
#include "finger_tk.h"
#include "finger_tkDlg.h"
#include "finger_tkThread.h"

#include "hardware/springprox/springprox.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CFinger_tkDlg dialog

CFinger_tkDlg::CFinger_tkDlg(CWnd * pParent /*=NULL*/ )
:CDialog(CFinger_tkDlg::IDD, pParent)
{
  //{{AFX_DATA_INIT(CFinger_tkDlg)
  m_fingers = _T("");
  m_fname = _T("");
  m_lname = _T("");
  m_id = _T("");
  m_msg1 = _T("");
  m_msg2 = _T("");
  m_tag = _T("");
  //}}AFX_DATA_INIT
  // Note that LoadIcon does not require a subsequent DestroyIcon in Win32
  m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CFinger_tkDlg::DoDataExchange(CDataExchange * pDX)
{
  CDialog::DoDataExchange(pDX);
  //{{AFX_DATA_MAP(CFinger_tkDlg)
  DDX_Control(pDX, IDC_WRITE, m_write);
  DDX_Control(pDX, IDC_VERIFY, m_verify);
  DDX_Control(pDX, IDC_READ, m_read);
  DDX_Control(pDX, IDC_ENROLL, m_enroll);
  DDX_Control(pDX, IDC_CANCEL, m_cancel);
  DDX_Control(pDX, IDC_APPLY, m_apply);
  DDX_Control(pDX, IDC_EDT_FNAME, m_fname_ctrl);
  DDX_Control(pDX, IDC_EDT_LNAME, m_lname_ctrl);
  DDX_Control(pDX, IDC_EDT_ID, m_id_ctrl);
  DDX_Text(pDX, IDC_EDT_FGR, m_fingers);
  DDX_Text(pDX, IDC_EDT_FNAME, m_fname);
  DDX_Text(pDX, IDC_EDT_LNAME, m_lname);
  DDX_Text(pDX, IDC_EDT_ID, m_id);
  DDX_Text(pDX, IDC_EDT_MSG1, m_msg1);
  DDX_Text(pDX, IDC_EDT_MSG2, m_msg2);
  DDX_Text(pDX, IDC_EDT_TAG, m_tag);
  //}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CFinger_tkDlg, CDialog)
  //{{AFX_MSG_MAP(CFinger_tkDlg)
  ON_BN_CLICKED(IDC_ENROLL, OnEnroll)
ON_BN_CLICKED(IDC_VERIFY, OnVerify)
ON_BN_CLICKED(IDC_READ, OnRead)
ON_BN_CLICKED(IDC_WRITE, OnWrite)
ON_BN_CLICKED(IDC_APPLY, OnApply)
ON_BN_CLICKED(IDC_SIMUL, OnSimul)
ON_BN_CLICKED(IDC_CANCEL, OnCancel) ON_WM_CLOSE()
  //}}AFX_MSG_MAP
END_MESSAGE_MAP()
/////////////////////////////////////////////////////////////////////////////
// CFinger_tkDlg message handlers
     BOOL CFinger_tkDlg::OnInitDialog()
{
  CDialog::OnInitDialog();

  // Set the icon for this dialog.  The framework does this automatically
  //  when the application's main window is not a dialog
  SetIcon(m_hIcon, TRUE);       // Set big icon
  SetIcon(m_hIcon, FALSE);      // Set small icon

  CenterWindow(GetDesktopWindow()); // center to the hpc screen

  readerActive = FALSE;
  return TRUE;                  // return TRUE  unless you set the focus to a control
}

void CFinger_tkDlg::OnClose()
{
  if (readerActive)
  {
    stop_SproxThread();
    readerActive = FALSE;
    SPROX_ReaderClose();
  }

  CDialog::OnClose();
}

BOOL CFinger_tkDlg::readerActivate()
{
  SWORD rc;

  if (readerActive)
    return TRUE;

  CWaitCursor patient;

  m_msg1 = "Looking for SpringBIO reader...";
  m_msg2 = "";
  UpdateData(FALSE);

  rc = SPROX_ReaderOpen(NULL);
  if (rc != MI_OK)
  {
    m_msg1 = "SpringBIO reader not found";
    m_msg2 = "";
    UpdateData(FALSE);

    MessageBox(_T
               ("Please make sure that the SpringBIO reader is plugged in the PDA"),
               _T("Reader not found"), 0);
    return FALSE;
  }

  rc = SPROX_MSO_Open(NULL, NULL, NULL);
  if (rc != MI_OK)
  {
    SPROX_ReaderClose();

    m_msg1 = "Not a SpringBIO reader";
    m_msg2 = "";
    UpdateData(FALSE);

    MessageBox(_T
               ("Please make sure that the SpringBIO reader is plugged in the PDA"),
               _T("Fingerprint reader not available"), 0);
    return FALSE;
  }

  if (!start_SproxThread())
  {
    SPROX_ReaderClose();

    m_msg1 = "Failed to create thread";
    m_msg2 = "";
    UpdateData(FALSE);
    return FALSE;
  }

  m_msg1 = "SpringBIO reader : OK";
  m_msg2 = "";
  UpdateData(FALSE);

  readerActive = TRUE;
  return TRUE;
}

/*
 * Sequencer's glue
 * ----------------
 */

void CFinger_tkDlg::UpdateControls(void)
{
  switch (currentStatus)
  {
    case STATUS_NONE:          /* We can only "read" or "enroll" */
      m_id_ctrl.SetReadOnly(TRUE);
      m_lname_ctrl.SetReadOnly(TRUE);
      m_fname_ctrl.SetReadOnly(TRUE);
      m_apply.EnableWindow(FALSE);
      m_cancel.EnableWindow(FALSE);
      m_read.EnableWindow(TRUE);
      m_write.EnableWindow(FALSE);
      m_verify.EnableWindow(FALSE);
      m_enroll.EnableWindow(TRUE);
      break;

    case STATUS_VERIFY:        /* We can only "cancel" */
      m_id_ctrl.SetReadOnly(TRUE);
      m_lname_ctrl.SetReadOnly(TRUE);
      m_fname_ctrl.SetReadOnly(TRUE);
      m_apply.EnableWindow(FALSE);
      m_cancel.EnableWindow(TRUE);
      m_read.EnableWindow(FALSE);
      m_write.EnableWindow(FALSE);
      m_verify.EnableWindow(FALSE);
      m_enroll.EnableWindow(FALSE);
      break;

    case STATUS_READING:       /* We can only "cancel" */
      m_id_ctrl.SetReadOnly(TRUE);
      m_lname_ctrl.SetReadOnly(TRUE);
      m_fname_ctrl.SetReadOnly(TRUE);
      m_apply.EnableWindow(FALSE);
      m_cancel.EnableWindow(TRUE);
      m_read.EnableWindow(FALSE);
      m_write.EnableWindow(FALSE);
      m_verify.EnableWindow(FALSE);
      m_enroll.EnableWindow(FALSE);
      break;

    case STATUS_READ:          /* We can only "verify" or "cancel" */
      m_id_ctrl.SetReadOnly(TRUE);
      m_lname_ctrl.SetReadOnly(TRUE);
      m_fname_ctrl.SetReadOnly(TRUE);
      m_apply.EnableWindow(FALSE);
      m_cancel.EnableWindow(TRUE);
      m_read.EnableWindow(FALSE);
      m_write.EnableWindow(FALSE);
      m_verify.EnableWindow(TRUE);
      m_enroll.EnableWindow(FALSE);
      break;

    case STATUS_VERIFIED_KO:
    case STATUS_VERIFIED_OK:   /* We can "verify" again, or "read" */
      m_id_ctrl.SetReadOnly(TRUE);
      m_lname_ctrl.SetReadOnly(TRUE);
      m_fname_ctrl.SetReadOnly(TRUE);
      m_apply.EnableWindow(FALSE);
      m_cancel.EnableWindow(FALSE);
      m_read.EnableWindow(TRUE);
      m_write.EnableWindow(FALSE);
      m_verify.EnableWindow(TRUE);
      m_enroll.EnableWindow(TRUE);
      break;


    case STATUS_ENROLL_EDIT:   /* We can only "apply" or "cancel" */
      m_id_ctrl.SetReadOnly(FALSE);
      m_lname_ctrl.SetReadOnly(FALSE);
      m_fname_ctrl.SetReadOnly(FALSE);
      m_apply.EnableWindow(TRUE);
      m_cancel.EnableWindow(TRUE);
      m_read.EnableWindow(FALSE);
      m_write.EnableWindow(FALSE);
      m_verify.EnableWindow(FALSE);
      m_enroll.EnableWindow(FALSE);
      break;

    case STATUS_ENROLL_CAPTURE:  /* We can only "cancel" */
      m_id_ctrl.SetReadOnly(TRUE);
      m_lname_ctrl.SetReadOnly(TRUE);
      m_fname_ctrl.SetReadOnly(TRUE);
      m_apply.EnableWindow(FALSE);
      m_cancel.EnableWindow(TRUE);
      m_read.EnableWindow(FALSE);
      m_write.EnableWindow(FALSE);
      m_verify.EnableWindow(FALSE);
      m_enroll.EnableWindow(FALSE);
      break;

    case STATUS_ENROLL_READY:  /* We can "write" or "verify" or "cancel" */
      m_id_ctrl.SetReadOnly(TRUE);
      m_lname_ctrl.SetReadOnly(TRUE);
      m_fname_ctrl.SetReadOnly(TRUE);
      m_apply.EnableWindow(FALSE);
      m_cancel.EnableWindow(TRUE);
      m_read.EnableWindow(FALSE);
      m_write.EnableWindow(TRUE);
      m_verify.EnableWindow(TRUE);
      m_enroll.EnableWindow(FALSE);
      break;

    case STATUS_ENROLL_WRITING:  /* We can only "cancel" */
      m_id_ctrl.SetReadOnly(TRUE);
      m_lname_ctrl.SetReadOnly(TRUE);
      m_fname_ctrl.SetReadOnly(TRUE);
      m_apply.EnableWindow(FALSE);
      m_cancel.EnableWindow(TRUE);
      m_read.EnableWindow(FALSE);
      m_write.EnableWindow(FALSE);
      m_verify.EnableWindow(FALSE);
      m_enroll.EnableWindow(FALSE);
      break;

    case STATUS_ENROLL_WRITTEN:  /* We can now "read" or "verify" or "enroll" */
      m_id_ctrl.SetReadOnly(TRUE);
      m_lname_ctrl.SetReadOnly(TRUE);
      m_fname_ctrl.SetReadOnly(TRUE);
      m_apply.EnableWindow(FALSE);
      m_cancel.EnableWindow(FALSE);
      m_read.EnableWindow(TRUE);
      m_write.EnableWindow(FALSE);
      m_verify.EnableWindow(TRUE);
      m_enroll.EnableWindow(TRUE);
      break;
  }
}

/*
 * Cancel pending action
 * ---------------------
 */
void CFinger_tkDlg::OnCancel()
{
  if (readerActive)
  {
    CWaitCursor patient;

    stop_SproxThread();
    readerActive = FALSE;
    SPROX_ReaderClose();
  }

  switch (currentStatus)
  {
    case STATUS_VERIFY:
    {
      /* Verification cancelled */
      m_msg1 = "Verification cancelled";
      m_msg2 = "";

      /* Back to previous mode */
      currentStatus = currentStatus_verify;
    }
      break;

    case STATUS_READING:
    {
      /* Read cancelled */
      m_msg1 = "Read cancelled";
      m_msg2 = "";

      /* Clear the data */
      m_id = "";
      m_lname = "";
      m_fname = "";
      m_tag = "";
      m_fingers = "";

      /* Idle mode */
      currentStatus = STATUS_NONE;
    }
      break;

    case STATUS_ENROLL_EDIT:
    case STATUS_ENROLL_CAPTURE:
    case STATUS_ENROLL_READY:
    {
      /* Enrollment cancelled */
      m_msg1 = "Enrollment cancelled";
      m_msg2 = "";

      /* Clear the data */
      m_id = "";
      m_lname = "";
      m_fname = "";
      m_tag = "";
      m_fingers = "";

      /* Idle mode */
      currentStatus = STATUS_NONE;
    }
      break;

    case STATUS_ENROLL_WRITING:
    {
      /* Cancel tag writing */
      m_msg1 = "Write cancelled";
      m_msg2 = "";

      /* Clear the tag data */
      m_tag = "";

      /* Still ready to write */
      currentStatus = STATUS_ENROLL_READY;
    }
      break;

    default:
    {
      m_msg1 = "";
      m_msg2 = "";
      m_id = "";
      m_lname = "";
      m_fname = "";
      m_tag = "";
      m_fingers = "";
      currentStatus = STATUS_NONE;
    }
      break;
  }

  UpdateControls();
  UpdateData(FALSE);
}

/*
 *
 * User verification process
 * *************************
 * 1) read user's tag (STATUS_READING)
 * 2) display user's data and wait for verification (STATUS_READ)
 * 3) user's has been verified (STATUS_VERIFIED_OK or STATUS_VERIFIED_KO)
 *
 */

void CFinger_tkDlg::OnRead()
{
  if (!readerActivate())
    return;

  /* Display what's going on */
  m_msg1 = "Reading user's data";
  m_msg2 = "Put the tag on the reader...";

  /* Clear the data */
  m_id = "";
  m_lname = "";
  m_fname = "";
  m_tag = "";
  m_fingers = "";

  /* Reading in progress */
  currentStatus = STATUS_READING;

  UpdateControls();
  UpdateData(FALSE);
}


void CFinger_tkDlg::OnVerify()
{
  if (!readerActivate())
    return;

  /* Display what's going on */
  m_msg1 = "User's verification";
  m_msg2 = "Waiting for fingerprint reader...";

  /* Capture in progress, remember previous mode */
  currentStatus_verify = currentStatus;
  currentStatus = STATUS_VERIFY;

  UpdateControls();
  UpdateData(FALSE);
}

/*
 *
 * User enrollment process
 * ***********************
 *
 * Steps :
 * 1) enter user's information (STATUS_ENROLL_EDIT)
 * 2) capture user's fingers (STATUS_ENROLL_CAPTURE)
 * 3) ready to write user's data on a tag (STATUS_ENROLL_READY)
 *
 */
void CFinger_tkDlg::OnEnroll()
{
  /* Display what's going on */
  m_msg1 = "Enrollment : enter user's data";
  m_msg2 = "Click Apply when done";

  /* Clear the data */
  m_id = "";
  m_lname = "";
  m_fname = "";
  m_tag = "";
  m_fingers = "";

  /* Editing in progress */
  currentStatus = STATUS_ENROLL_EDIT;

  UpdateControls();
  UpdateData(FALSE);
}



/*
 * Post user's information during enrollment process
 * Goes from STATUS_ENROLL_EDIT to STATUS_ENROLL_CAPTURE
 */
void CFinger_tkDlg::OnApply()
{
  LPCTSTR s;

  UpdateData(TRUE);

  /* Save entered data */
  while (m_id.GetLength() < 16)
    m_id = "0" + m_id;
  if (m_id.GetLength() > 16)
    m_id = m_id.Mid(0, 16);
  s = m_id;
  fromHEX(FingerData.user.user_id, sizeof(FingerData.user.user_id), s);

  s = m_lname;
  fromSTR(FingerData.user.last_name, sizeof(FingerData.user.last_name), s);
  s = m_fname;
  fromSTR(FingerData.user.first_name, sizeof(FingerData.user.first_name), s);

  /* Now we need the reader */
  if (!readerActivate())
    return;

  /* Display what's going on */
  m_msg1 = "Enrollment : 2 fingers acquisition";
  m_msg2 = "Waiting for fingerprint reader...";

  /* Capture in progress */
  currentStatus = STATUS_ENROLL_CAPTURE;

  UpdateControls();
  UpdateData(FALSE);
}

/*
 * Save user's information on a tag
 * Goes from STATUS_ENROLL_READY to STATUS_ENROLL_WRITING
 */
void CFinger_tkDlg::OnWrite()
{
  if (!readerActivate())
    return;

  /* Display what's going on */
  m_msg1 = "Enrollment : writing to tag";
  m_msg2 = "Put the tag on the reader...";

  /* Writing in progress */
  currentStatus = STATUS_ENROLL_WRITING;

  UpdateControls();
  UpdateData(FALSE);
}






void CFinger_tkDlg::OnSimul()
{
  switch (currentStatus)
  {
    case STATUS_VERIFY:
    {
      /* Consider read is OK */
      m_msg1 = "VERIFICATION : OK";
      m_msg2 = "You are !";

      switch (currentStatus_verify)
      {
        case STATUS_READ:
        case STATUS_VERIFIED_KO:
        case STATUS_VERIFIED_OK:
          currentStatus = STATUS_VERIFIED_OK;
          break;

        case STATUS_ENROLL_READY:
        case STATUS_ENROLL_WRITTEN:
          currentStatus = currentStatus_verify;
          break;

        default:
          currentStatus = STATUS_NONE;
      }
    }
      break;

    case STATUS_READING:
    {
      /* Consider tag reading is OK */
      m_msg1 = "Tag read, ready to verify";
      m_msg2 = "";

      m_id = "12345-6789";
      m_lname = "Smith";
      m_fname = "John";

      m_tag = "SAMPLE TAG 11223344556677";
      m_fingers = "2 fingers read";

      /* Ready to write */
      currentStatus = STATUS_READ;
    }
      break;

    case STATUS_ENROLL_CAPTURE:
    {
      /* Consider finger acquisition is OK */
      m_msg1 = "Enrollment : ready";
      m_msg2 = "Present user's tag and click Write";

      /* Assume we have read something */
      m_fingers = "2 fingers captured";

      /* Ready to write */
      currentStatus = STATUS_ENROLL_READY;
    }
      break;

    case STATUS_ENROLL_WRITING:
    {
      /* Consider tag writing is OK */
      m_msg1 = "Enrollment : done";
      m_msg2 = "User's data and fingers written to tag";

      /* Idle but happy */
      currentStatus = STATUS_ENROLL_WRITTEN;
    }
      break;
  }

  UpdateControls();
  UpdateData(FALSE);
}


void CFinger_tkDlg::display(TCHAR * msg1, TCHAR * msg2)
{
  if (msg1 != NULL)
    m_msg1 = msg1;
  if (msg2 != NULL)
    m_msg2 = msg2;
  UpdateData(FALSE);
}

void CFinger_tkDlg::timeout()
{
  switch (currentStatus)
  {
    case STATUS_READING:
    {
      /* Read cancelled */
      m_msg1 = "No tag found after 20s";
      m_msg2 = "Press read to try again";

      /* Clear the data */
      m_id = "";
      m_lname = "";
      m_fname = "";
      m_tag = "";
      m_fingers = "";

      /* Idle mode */
      currentStatus = STATUS_NONE;
    }
      break;

    case STATUS_ENROLL_WRITING:
    {
      /* Cancel tag writing */
      m_msg1 = "No tag found after 20s";
      m_msg2 = "Press write to try again";

      /* Clear the tag data */
      m_tag = "";

      /* Still ready to write */
      currentStatus = STATUS_ENROLL_READY;
    }
      break;
  }

  UpdateControls();
  UpdateData(FALSE);

  /* Power down the reader */
  if (readerActive)
  {
    CWaitCursor patient;

    readerActive = FALSE;
    SPROX_ReaderClose();
  }
}

void CFinger_tkDlg::result(int theResult)
{
  switch (currentStatus)
  {
    case STATUS_VERIFY:
    {
      /* Consider read is OK */
      if (theResult == RESULT_SUCCESS)
      {
        m_msg1 = "Verification : OK";
        m_msg2 = "The person is authenticated";
      } else if (theResult == RESULT_FAILED)
      {
        m_msg1 = "Verification : FAILED";
        m_msg2 = "The person is NOT authenticated";
      } else
      {
        m_msg2 = "The verification has aborted";
      }

      switch (currentStatus_verify)
      {
        case STATUS_READ:
        case STATUS_VERIFIED_KO:
        case STATUS_VERIFIED_OK:
          if (theResult == RESULT_SUCCESS)
          {
            currentStatus = STATUS_VERIFIED_OK;
          } else if (theResult == RESULT_FAILED)
          {
            currentStatus = STATUS_VERIFIED_KO;
          } else
          {
            currentStatus = currentStatus_verify;
          }
          break;

        case STATUS_ENROLL_READY:
        case STATUS_ENROLL_WRITTEN:
          currentStatus = currentStatus_verify;
          break;

        default:
          currentStatus = STATUS_NONE;
      }
    }
      break;

    case STATUS_READING:
    {
      /* Consider tag reading is OK */
      if (theResult == RESULT_SUCCESS)
      {
        TCHAR s[64 + 1];

        m_msg1 = "Tag read, ready to verify";
        m_msg2 = "";

        toHEX(s, FingerData.user.user_id, sizeof(FingerData.user.user_id));
        m_id = s;

        toSTR(s, FingerData.user.last_name,
              sizeof(FingerData.user.last_name));
        m_lname = s;
        toSTR(s, FingerData.user.first_name,
              sizeof(FingerData.user.first_name));
        m_fname = s;

        if ((FingerData.user.finger_size[0])
            && (FingerData.user.finger_size[1]))
        {
          m_fingers = "2 fingers read";
        } else
          if ((FingerData.user.finger_size[0])
              || (FingerData.user.finger_size[1]))
        {
          m_fingers = "1 finger read";
        } else
        {
          m_fingers = "No finger in the card";
        }

        /* Ready to verify */
        currentStatus = STATUS_READ;
      }
    }
      break;

    case STATUS_ENROLL_CAPTURE:
    {
      /* Consider finger acquisition is OK */
      if (theResult == RESULT_SUCCESS)
      {
        m_msg1 = "Enrollment : ready";
        m_msg2 = "Present user's tag and click Write";

        /* Assume we have read something */
        m_fingers = "2 fingers captured";

        /* Ready to write */
        currentStatus = STATUS_ENROLL_READY;
      } else if (theResult == RESULT_FAILED)
      {
        m_msg1 = "Enrollment : FAILED";
        m_msg2 = "The fingerprint has not been recorded";
      } else
      {
        m_msg2 = "The enrollment has aborted";
      }
    }
      break;

    case STATUS_ENROLL_WRITING:
    {
      /* Consider tag writing is OK */
      if (theResult == RESULT_SUCCESS)
      {
        TCHAR w_buffer[64 + 1];
        int i;

        m_msg1 = "Enrollment : done";
        m_msg2 = "User's data and fingers written to tag";

        /* Update tag */
        for (i = 0; i < sizeof(TagInfo); i++)
          w_buffer[i] = TagInfo[i];
        w_buffer[i] = '\0';
        m_tag = w_buffer;

        /* Idle but happy */
        currentStatus = STATUS_ENROLL_WRITTEN;
      }
    }
      break;
  }

  UpdateControls();
  UpdateData(FALSE);
}
