#include "stdafx.h"
#include "finger_tk.h"
#include "finger_tkDlg.h"
#include "finger_tkThread.h"
#include "common.h"

FINGERTK_DATA_ST FingerData;
char TagInfo[64];

HANDLE h_SproxThread = INVALID_HANDLE_VALUE;
DWORD id_SproxThread;
BOOL b_SproxThread;

DWORD WINAPI proc_SproxThread(void *param)
{
  DWORD timeout = 200;          /* about 20 seconds */

  while (b_SproxThread)
  {
    Sleep(100);
    if (timeout == 0)
      continue;
    switch (dlg.currentStatus)
    {
      case STATUS_READING:
        if (read_from_tag(&FingerData))
        {
          /* A tag has been read */
          timeout = 300;
          dlg.result(RESULT_SUCCESS);
        }
        break;

      case STATUS_ENROLL_WRITING:
        if (write_to_tag(&FingerData))
        {
          /* The tag has been written */
          timeout = 100;
          dlg.result(RESULT_SUCCESS);
        }
        break;

      case STATUS_VERIFY:
        dlg.result(verify(&FingerData));
        timeout = 100;
        break;

      case STATUS_ENROLL_CAPTURE:
        dlg.result(enroll(&FingerData));
        timeout = 300;
        break;

    }
    timeout--;
    if (timeout == 0)
    {
      dlg.timeout();
      break;
    }
  }

  h_SproxThread = INVALID_HANDLE_VALUE;
  return 0;
}

BOOL start_SproxThread(void)
{
  if (h_SproxThread != INVALID_HANDLE_VALUE)
    return FALSE;

  b_SproxThread = TRUE;
  h_SproxThread =
    CreateThread(NULL, 0, proc_SproxThread, NULL, 0, &id_SproxThread);

  if (h_SproxThread == INVALID_HANDLE_VALUE)
    return FALSE;

  return TRUE;
}

void stop_SproxThread(void)
{
  BYTE wait = 0;

  b_SproxThread = FALSE;

  while (h_SproxThread != INVALID_HANDLE_VALUE)
  {
    Sleep(100);
    wait++;
    if (wait >= 5)
      break;
  }

  if (h_SproxThread != INVALID_HANDLE_VALUE)
  {
    TerminateThread(h_SproxThread, 0);
    h_SproxThread = INVALID_HANDLE_VALUE;
  }
}
